#!/usr/bin/python
# -*- coding: utf-8 -*-

# Python imports
import cgi
import cgitb
import datetime

# Project imports
import HTML
import core

# Version 2024-04-01 20:00

# =========
# CONSTANTS
# =========
TYPE = "Rand'Orientation de la Côte d'Emeraude"
CITY = "Saint Cast le Guildo"
YEAR = "2024"
RECEIVER = "\tErica VIGNON\n\t19, rue Ambroise Bernard\n\t22100 Dinan\n"
WEB_PAGE = "http://www.dinan-course-orientation.fr/courses/2024/Rando-SaintCast/accueil.html\n"
TO = "secretariat@dinan-course-orientation.fr"
# TO = "boulet-eric@orange.fr"

OBJECT = (
    TYPE + " - " + CITY + " - " + YEAR + " : dossier d'inscription")
MSG_FOOTER = (
    "Ce message a été envoyé depuis "
    "le site http://www.dinan-course-orientation.fr")
MSG_RECEIVER = (
    "Nous avons bien reçu votre pré-inscription : ")
#
ERR_TEAM_NAME_MANDATORY = (
    "Le champ 'Nom de votre équipe' n'est pas rempli !")
ERR_TEAM_MAIL_MANDATORY = (
    "Le champ 'Adresse mél de la personne en charge "
    "de l'inscription' n'est pas rempli !")
ERR_TEAM_MAIL_CHECK_MANDATORY = (
    "Le champ 'Confirmation de cette adresse mél' n'est pas rempli !")
ERR_TEAM_MAIL_VALIDATION = (
    "Le champ 'Adresse mél de la personne en charge "
    "de l'inscription' ne correspond pas avec le champ "
    "'Confirmation de cette adresse mél' ! ")
ERR_TEAM_PHONE_MANDATORY = (
    "Le champ 'Téléphone portable' n'est pas rempli !")
ERR_TEAM_RACE_MANDATORY = (
    "Le champ 'Parcours' n'a pas été sélectionné !")
ERR_TEAM_SI_CODE_NUMBER = (
    "Le champ 'Numéro du pointeur Sport Ident' doit être un nombre !")
ERR_TEAM_SI_UNUSABLE = (
    "Le pointeur Sport Ident est incompatible "
    "avec ce circuit, sa mémoire est insuffisante !")
ERR_TEAM_SI_UNKNOWN = (
    "Le code du pointeur Sport Ident est erroné !")
ERR_PERSON_MANDATORY = (
    "Il n'y a aucun d'équipier dans votre équipe !")
#
ERR_SPAM_RESPONSE_MANDATORY = (
    "La réponse au 'Contrôle anti-spam' n'est pas rempli !")
ERR_SPAM_RESPONSE_BAD = (
    "La réponse au contrôle anti-spam est erronée !")
ERR_SPAM_TECHNICAL_ERROR_1 = (
    "Erreur technique : dysfonctionnement de l'anti-spam !")
ERR_SPAM_TECHNICAL_ERROR_2 = (
    "Erreur technique : état du formulaire erronée !")


# =============================================================================
# Step 1 view : team registration
# =============================================================================

def display_team_registation():

    print str(HTML.HEADER_HTTP)
    print HTML.HTML_HEADER

    # Start page
    print ('<body>')
    print (str(HTML.BLOCK_MENU))
    print ('<div class="w3-row w3-marging-top w3-light-gray">')
    print ('<div class="w3-col l3 w3-padding-16">')
    print (str(HTML.BLOCK_LOGO))
    print (str(HTML.BLOCK_EXTERNAL_NAV))
    print ('</div>')
    print ('<div class="w3-col l7 s12 w3-padding-16">')
    print ('<div class="w3-container w3-card-4 w3-white w3-padding-bottom">')

    # Title block
    print (
        '<!-- FORM -->'
        '<h2>Formulaire de pré-inscription (Etape 1/3)</h2>'
        '<form id="team" method="post" action="./inscription.py">'
        '<hr>'
        '<h3>La pré-inscription en trois étapes</h3>'
        '<ol>'
        '<li>Remplissez ce formulaire, en n\'omettant aucune information.</li>'
        '<li>Après validation, vous recevrez un courriel à l\'adresse que '
        'vous aurez indiqué.</li>'
        '<li>Postez le dossier complet (règlement, formulaire d\'inscription '
        'et pièces justificatives) à l\'adresse postale indiquée.</li>'
        '</ol>')

    # Errors block
    if len(errors) > 0:
        print (
            '<hr>'
            '<h3>Erreurs</h3>'
            '<p class="w3-text-red">'
            'Oups ... erreur(s) détectée(s) dans le formulaire :</p>'
            '<ul class="w3-text-red">')
        for e in errors:
            print '<li>{0}</li>'.format(e)
        print '</ul>'

    # Team block
    print (
        '<hr>'
        '<h3>L\'équipe</h3>'
        '<label>Nom de votre équipe : </label>'
        '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="text" id="team_name" '
        'name="team_name" value="{0}" tabindex="1"/>').format(
            cgi.escape(t.name, quote=True))
    print (
        '<label>Adresse mél de la personne en '
        'charge de l\'inscription : </label>'
        '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="email" id="team_mail" '
        'name="team_mail" value="{0}" tabindex="2"/>').format(
            cgi.escape(t.mail, quote=True))
    print (
        '<label>Confirmation de cette adresse mél : </label>'
        '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="email" id="mail_check" '
        'name="mail_check" value="{0}" tabindex="3"/>').format(
            cgi.escape(mail_check, quote=True))
    print (
        '<label>Téléphone portable : </label>'
        '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="text" name="team_phone" '
        'tabindex="4" placeholder="Téléphone utilisé le jour de la course." '
        'value="{0}"/>').format(
            cgi.escape(t.phone, quote=True))
    print (
        '<label>Parcours : </label>'
        '<select class="w3-input w3-border w3-pale-blue w3-round-large" name="team_race_code" tabindex="5">'
        '<option value="NONE">Sélectionnez votre parcours ...</option>')
    for r in core.Race.values:
        if r[3]:
            s = ""
            if r[0] == t.race_code:
                s = 'selected'
            print '<option value="{0}" {1}>{2} (env. {3} kms)</option>'.format(
                r[0], s, r[1], r[2])
    print '</select>'
    
    
    si = ""
    if t.SI_code > 0:
        si = str(t.SI_code)
    print (
        '<label>Numéro pointeur Sport Ident : </label>'
        '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="text" name="team_si_code" '
        'placeholder="Laissez vide si vous n\'avez pas de pointeur Sport Ident'
        'Sport Ident" value="{0}" tabindex="6"/>').format(si)


    # Persons block 
    print (
        '<hr>'
        '<p>Composez votre équipe de 1 à 6 personnes.</p>')
        
    #    '<p><b>Note : </b>')
        
    #    'Pour les familles, si vous souhaitez constituer des équipes de 4 '
    #    'ou 5 personnes, n\'hésitez pas à nous contacter.</p><br>')
        
    print ('<div class="w3-row-padding">')
    #
    # Person N block
    #
    for i in range(6): 
        print ('<div class="w3-col s12 m12 l4">')
        if not i:
            print('<h3>Capitaine</h3>')
        else:
            print('<h3>Equipier ' + str(i) +'</h3>')
        s = ""
        if len(t.persons) > i:
            s = t.persons[i].name
        print (
            '<label>Nom : </label>'
            '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="text" name="persons_' + str(i) +'_name" value="{0}" '
            'tabindex="7"/>').format(cgi.escape(s, quote=True))
        s = ""
        if len(t.persons) > i:
            s = t.persons[i].first_name
        print (
            '<label>Prénom : </label>'
            '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="text" name="persons_' + str(i) +'_first_name" '
            'value="{0}" tabindex="8"/>').format(cgi.escape(s, quote=True))    
            
        print (
            '<label>Date de naissance : </label><br>'
            '<select class="w3-input w3-border w3-pale-blue w3-round-large" name="persons_' + str(i) +'_day" tabindex="10">'
            '<option value="0">Jour</option>')
        for d in range(1, 32):
            if len(t.persons) > i:
                s = ""
                if d == t.persons[i].day:
                    s = "selected"
            print '<option value="{0}" {1}>{2}</option>'.format(str(d), s, str(d))
        print (
            '</select>'
            '<select class="w3-input w3-border w3-pale-blue w3-round-large" name="persons_' + str(i) +'_month" tabindex="10">'
            '<option value="0">Mois</option>')
        for m in range(1, 13):
            if len(t.persons) > i:
                s = ""
                if m == t.persons[i].month:
                    s = "selected"
            print '<option value="{0}" {1}>{2}</option>'.format(
                m, s, core.Month().label(m))
        print (
            '</select>'
            '<select class="w3-input w3-border w3-pale-blue w3-round-large" name="persons_' + str(i) +'_year" tabindex="10">'
            '<option value="0">Année</option>')
        for y in range(1930, datetime.datetime.now().year + 1):
            if len(t.persons) > i:
                s = ""
                if y == t.persons[i].year:
                    s = "selected"
            print '<option value="{0}" {1}>{2}</option>'.format(str(y), s, str(y))
        print '</select>'
        ffco = ""
        if len(t.persons) > i:
            if t.persons[i].FFCO_code > 0:
                ffco = str(t.persons[i].FFCO_code)
        print (
            '<label>Numéro de licence FFCO : </label>'
            '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="text" name="persons_' + str(i) +'_ffco_code" '
            'placeholder="Laissez vide si vous n\'êtes pas licencié FFCO" '
            'value="{0}" tabindex="11"/></div>').format(ffco)
            
    print ('</div>')

    #
    # Other block
    #
    print (
        '<hr>'
        '<h3>Divers</h3>'
        '<label>Indiquez ici vos demandes, questions ou remarques :</label>'
        '<textarea class="w3-input w3-border w3-pale-blue w3-round-large" id="message" name="message" tabindex="21" '
        'cols="30" rows="8">{0}</textarea>').format(cgi.escape(message))
    w = ""
    if t.want_news_letter:
        w = "checked"
    print (
        '<br>'
        '<input class="w3-border w3-pale-blue w3-round-large w3-margin-bottom" type="checkbox" name="team_want_news_letter" '
        'tabindex="22" value="Y" {0}/>'
        ' Oui je souhaite recevoir votre lettre d\'information (désabonnement '
        'possible sur simple demande) <br>').format(w)
    if state != "EDIT":
        print (
            '<label>Contrôle anti-spam : {0}</label>'
            '<input class="w3-input w3-border w3-pale-blue w3-round-large" type="text" tabindex="23" '
            'name="spam_response" id="spam_response"/>').format(spam.question)

    #
    # Hidden block
    #
    print '<input type="hidden" name="state" value="{0}"/>'.format(state)

    #
    # Buttons block
    #
    print (
        '<hr>'
        '<input class="w3-button w3-green w3-margin-bottom w3-right" type="submit" name="page" '
        'value="Etape suivante" tabindex="24"/>'
        '<input type="hidden" name="spam_code" value="{0}"/>').format(
            spam.code)
    
        
    # End  ...
    print (
        '</form>'
        '</div>'
        '<p><small>App. version {0}</small></p></div></div>').format(core.version)
    
    print str(HTML.BLOCK_FOOTER)
    print '</body></html>'

# =============================================================================
# Step 2 view : Validation
# =============================================================================


def display_report():
    """
        This display report page.
    """
    print str(HTML.HEADER_HTTP)
    print HTML.HTML_HEADER
    # Start page
    print ('<body>')
    print (str(HTML.BLOCK_MENU))
    print ('<div class="w3-row w3-marging-top w3-light-gray">')
    print ('<div class="w3-col l3 w3-padding-16">')
    print (str(HTML.BLOCK_LOGO))
    print (str(HTML.BLOCK_EXTERNAL_NAV))
    print ('</div>')
    print ('<div class="w3-col l7 s12 w3-padding-16 ">')
    print ('<div class="w3-container w3-card-4 w3-white w3-padding-bottom">')


    # Title block
    print (
        '<!-- FORM -->'
        '<h2>Formulaire de pré-inscription (Etape 2/3)</h2>'
        '<form id="contact" method="post" action="inscription.py">')
    if t.want_news_letter:
        print '<input type="hidden" name="team_want_news_letter" value="Y"/>'
    print (
        '<input type="hidden" name="team_name" value="{0}"/>'
        '<input type="hidden" name="team_mail" value="{1}"/>'
        '<input type="hidden" name="mail_check" value="{2}"/>'
        '<input type="hidden" name="team_phone" value="{3}"/>'
        '<input type="hidden" name="team_race_code" value="{4}"/>'
        '<input type="hidden" name="message" value="{5}"/>'
        '<input type="hidden" name="state" value="{6}"/>'
        '<input type="hidden" name="team_si_code" value="{7}"/>').format(
            cgi.escape(t.name, quote=True),
            cgi.escape(t.mail, quote=True),
            cgi.escape(mail_check, quote=True),
            cgi.escape(t.phone, quote=True),
            t.race_code,
            cgi.escape(message, quote=True),
            state,
            cgi.escape(str(t.SI_code), quote=True))
            
    for i, p in enumerate(t.persons): 
        print (
            '<input type="hidden" name="persons_' + str(i) + '_name" value="{0}"/>'
            '<input type="hidden" name="persons_' + str(i) + '_first_name" value="{1}"/>'
            '<input type="hidden" name="persons_' + str(i) + '_day" value="{2}"/>'
            '<input type="hidden" name="persons_' + str(i) + '_month" value="{3}"/>'
            '<input type="hidden" name="persons_' + str(i) + '_year" value="{4}"/>'
            '<input type="hidden" name="persons_' + str(i) + '_ffco_code" value="{5}"/>').format(
                cgi.escape(p.name, quote=True),
                cgi.escape(p.first_name, quote=True),
                str(p.day),
                str(p.month),
                str(p.year),
                cgi.escape(str(p.FFCO_code), quote=True))
                    

    # Errors block
    if len(errors) > 0:
        print (
            '<h3>Erreurs</h3>'
            '<p class="w3-text-red">'
            'Oups ... erreur(s) détectée(s) dans le formulaire :</p>'
            '<ul class="w3-text-red">')
        for e in errors:
            print '<li>{0}</li>'.format(e)
        print '</ul><hr>'

    want = "Non"
    if t.want_news_letter:
        want = "Oui"

    # Team block
    print (
        '<h3>Votre équipe</h3>'
        '<p><b>Nom de votre équipe : </b>{0}</p>'
        '<p><b>Courriel de votre équipe : </b>{1}</p>'
        '<p><b>Téléphone portable : </b>{2}</p>'
        '<p><b>Parcours : </b>{3} (environ {4} kms)</p>').format(
            cgi.escape(t.name, quote=True),
            cgi.escape(t.mail, quote=True),
            cgi.escape(t.phone, quote=True),
            core.Race(code=t.race_code).label,
            core.Race(code=t.race_code).dist)
            
    if t.SI_code > 0:
        print (
            '<p><b>Pointeur Sport Ident : </b>{0} ({1} mémoire {2} '
            'postes)</p>').format(
                cgi.escape(str(t.SI_code), quote=True),
                core.Card(code=t.SI_code).label,
                core.Card(code=t.SI_code).mem)
    else:
        print '<p><b>Pointeur Sport Ident : </b>Location</p>'
        
    print (
        '<p><b>Abonnement lettre d\'information : </b>{0}</p>').format(want)
    if len(message) > 0:
        print ('<p><b>Message : </b>{0}</p>').format(
            cgi.escape(message, quote=True))
    print (
        '<hr>'
        '<div class="w3-row">')

    for i, p in enumerate(t.persons):
        ffco = "Pass\'O"
        if p.FFCO_code > 0:
            ffco = str(p.FFCO_code)
        print ('<div class="w3-col l4 s12 m12">')
        if not i:
            print('<h3>Capitaine</h3>')
        else:
            print('<h3>Equipier ' + str(i) + '</h3>')
        
        print(
            '<p><b>Nom : </b>{0}</p>'
            '<p><b>Prénom : </b>{1}</p>'
            '<p><b>Année de naissance : </b>{2}/{3}/{4}</p>'
            '<p><b>Numéro de licence FFCO : </b>{5}</p>'
            '</div>').format(
                cgi.escape(p.name, quote=True),
                cgi.escape(p.first_name, quote=True),
                str(p.day),
                str(p.month),
                str(p.year),
                ffco)

    print ('</div>')

    print (
        '<hr>'
        '<h3>Montant de l\'inscription</h3>'
        '<table class="w3-table-all">'
        '<tr><th width="55%">&nbsp</th><th width="15%">Nb</th>'
        '<th width="15%">Montant unit.</th><th width="15%">Total</th><tr>'
        '<tr><td>Carte</td><td>1</td><td>{0} €</td><td>{0} €</td></tr>').format(
            core.Price.map_set)
            
    if t.nb_adult > 0:
        print (
            '<tr><td>Engagement adulte (plus 18 ans)</td>'
            '<td>{0}</td><td>{1} €</td><td>{2} €</td></tr>').format(
                t.nb_adult,
                core.Price.adult,
                core.Price.adult * t.nb_adult)
    if t.nb_young > 0:
        print (
            '<tr><td>Engagement jeune (14 à 17 ans)</td>'
            '<td>{0}</td><td>{1} €</td><td>{2} €</td></tr>').format(
                t.nb_young,
                core.Price.young,
                t.nb_young * core.Price.young)
    if t.nb_child > 0:
        print (
            '<tr><td>Engagement enfant (6 à 13 ans)</td>'
            '<td>{0}</td><td>{1} €</td><td>{2} €</td></tr>').format(
                t.nb_child,
                core.Price.child,
                t.nb_child * core.Price.child)
    if t.nb_baby > 0:
        p = ""
        if core.Price.baby == 0:
            p = "Gratuit"
        else:
            p = str(t.nb_baby * core.Price.baby), " €"
        print (
            '<tr><td>Engagement poussin (moins 6 ans)</td>'
            '<td>{0}</td><td>{1}</td><td>{2} €</td></tr>').format(
                t.nb_baby, p, t.nb_baby * core.Price.baby)
    if t.nb_pass_o_leasure > 0:
        print (
            '<tr><td>Pass\'loisir (licence journée non-chrono)</td>'
            '<td>{0}</td><td>{1} €</td><td>{2} €</td></tr>').format(
                t.nb_pass_o_leasure,
                core.Price.pass_o_leasure,
                t.nb_pass_o_leasure * core.Price.pass_o_leasure)
    if t.nb_pass_o_sport:
        print (
            '<tr><td>Pass\'découverte (licence journée chrono)</td>'
             '<td>{0}</td><td>{1} €</td><td>{2} €</td></tr>').format(
                t.nb_pass_o_sport,
                core.Price.pass_o_sport,
                t.nb_pass_o_sport * core.Price.pass_o_sport)
                
    if t.SI_code == 0:
        print(
            '<tr><td>Location pointeur</td>'
            '<td>1</td><td>Gratuit</td><td>0 €</td></tr>')
    print(
        '<tr><td colspan="3"><b>Montant à régler</b></td>'
        '<td><b>{0} €</b></td></tr>'
        '</table>').format(t.price)

    print(
        '<hr>'
        '<input class="w3-button w3-orange w3-left w3-margin-left w3-margin-bottom" type="submit" name="page" value="Corriger" />'
        '<input class="w3-button w3-green w3-right w3-margin-left w3-margin-bottom" type="submit" name="page" value="Envoyer" />')

    # Ending ...
    print (
        '</form>'
        '</div>'
        '<p><small>App. version {0}</small></p>'
        '</div></div>').format(core.version)
    print str(HTML.BLOCK_FOOTER)
    print '</body></html>'

# =============================================================================
# Step 3 view : Ok
# =============================================================================


def display_ok():
    """
        This display report Ok send.
    """
    print str(HTML.HEADER_HTTP)
    print HTML.HTML_HEADER
    # Start page
    print ('<body>')
    print (str(HTML.BLOCK_MENU))
    print ('<div class="w3-row w3-marging-top w3-light-gray">')
    print ('<div class="w3-col l3 w3-padding-16">')
    print (str(HTML.BLOCK_LOGO))
    print (str(HTML.BLOCK_EXTERNAL_NAV))
    print ('</div>')
    print ('<div class="w3-col l7 s12 w3-padding-16 ">')
    print ('<div class="w3-container w3-card-4 w3-white w3-padding-bottom">')

    print (
        '<h2>Formulaire de pré-inscription (Etape 3/3)</h2><br><hr>'
        '<p>Votre pré-inscription nous a été envoyée.</p>'
        '<p>Vous allez recevoir dans quelques minutes à l\'adresse mail '
        ' que vous avez indiqué, un message de confirmation contenant '
        ' les instructions à suivre pour compléter votre inscription. '
        ' Dans le cas, où vous ne recevez pas le message de confirmation, n\'oubliez pas '
        ' de vérifier votre dossier "Spam", car votre hébergeur peut avoir '
        ' une politique de filtrage des messages. '
        ' Sinon contactez-nous !<hr></p>'
        '<p><a href="http://www.dinan-course-orientation.fr/index.html">'
        'Retourner à la page d\'accueil.</a></p>')

    print (
        '</div>'
        '<p><small>App. version {0}</small></p>'
        '</div>'
        '</div>').format(core.version)
    print str(HTML.BLOCK_FOOTER)
    print '</body></html>'

# =============================================================================
# Message txt
# =============================================================================


def message_ascii():
    msg = (
        "Chers amis orienteurs,\n\n"
        "Merci de vous être pré-inscrit à la " + TYPE + " - " + CITY + " - " + YEAR +" .\n\n"
        "Pour compléter votre dossier d'inscription, veuillez nous envoyer :\n"
        "* ce message qui nous rappelle vos coordonnées\n")
    if t.SI_code == 0:
        msg = msg + (
            "* un chèque de caution de 50 euros à l'ordre de "
            "\"Dinan Course d'Orientation\" (non encaissé et couvrant la "
            " valeur du pointeur électronique)\n")
    
    r = core.Race()
    r.select(t.race_code)
    if r.is_chrono:
        for p in t.persons:
            if p.FFCO_code == 0 :
                msg = msg + (
                    "* l'attestation médical de {0} {1} (modèle téléchargeable sur la page d'information de la " + TYPE + "\n").format(p.first_name, p.name)

    msg = msg + (
        "* un chèque de règlement de {0} euros à l'ordre de "
        "\"Dinan Course d'Orientation\"\n").format(t.price)
        
    if len(t.persons) > 1:
        t.nb_map = 2
    msg = msg + (
        "Le courrier doit être posté à l'adresse suivante :\n" + RECEIVER +
        "\n"
        "Par le fait de vous inscrire, vous reconnaissez que tous les "
        "coureurs composant l'équipe s'engagent à respecter le réglement de "
        "la course (disponible à cette adresse : "  + WEB_PAGE + ")\n\n"
        "Si vous souhaitez effectuer une modification de votre dossier "
        "d'inscription ou simplement poser une question, n'hésitez pas à nous "
        "contacter par messagerie ou à l'aide du formulaire de contact sur "
        "notre site internet.\n"
        "\n"
        "VOTRE EQUIPE :\n"
        "--------------\n"
        "Nom de l'équipe : {0}\n"
        "Courriel de l'équipe : {1} \n"
        "Téléphone portable :{2}\n"
        "Parcours : {3}\n").format(
            t.name,
            t.mail,
            t.phone,
            core.Race(code=t.race_code).label)
            
    si_code = "Location"
    if t.SI_code > 0:
        si_code = str(t.SI_code)
    msg = msg + "Pointeur SI : {0}".format(si_code)
    
    for i, p in enumerate(t.persons):
        
        ffco = "Pass\'O"
        if p.FFCO_code > 0:
            ffco = str(p.FFCO_code)
        msg = msg + "\n"
        if not i:
             msg = msg + "CAPITAINE " + str(i) + " :\n"
        else:
            msg = msg + "EQUIPIER " + str(i) + ":\n"
            
        msg = msg + (
            "------------\n"
            "Nom : {0}\n"
            "Prénom : {1}\n"
            "Date de naissance : {2}/{3}/{4}\n"
            "Licence FFCO : {5}\n\n").format(
                p.name,
                p.first_name,
                p.day,
                p.month,
                p.year,
                ffco)

    msg = msg + (
        "A REGLER : \n"
        "----------\n")

    msg = msg + (
        "* Carte : {0} euros\n").format(core.Price.map_set)    
    
    if t.nb_adult > 0:
        msg = msg + (
            "* Engagement adulte (plus 18 ans) : {0} x {1} euros\n").format(
                t.nb_adult,
                core.Price.adult)
    if t.nb_young > 0:
        msg = msg + (
            "* Engagement jeune (14 à 17 ans) : {0} x {1} euros\n").format(
                t.nb_young,
                core.Price.young)
    if t.nb_child > 0:
        msg = msg + (
            "* Engagement enfant (6 à 13 ans) : {0} x {1} euros\n").format(
                t.nb_child,
                core.Price.child)
    if t.nb_baby > 0:
        p = ""
        if core.Price.baby == 0:
            p = "Gratuit"
        else:
            p = str(t.nb_baby * core.Price.baby), " €"
        msg = msg + (
            "* Engagement poussin (moins 6 ans) : {0} x {1} euros\n").format(
                t.nb_baby, p)
    if t.nb_pass_o_leasure > 0 :
        msg = msg + (
            "* Pass\'loisir (licence journée non-chrono) : {0} x {1} euros\n").format(
                t.nb_pass_o_leasure,
                core.Price.pass_o_leasure)
    if t.nb_pass_o_sport > 0:
        msg = msg + (
            "* Pass\'découverte (licence journée chrono) : {0} x {1} euros\n").format(
                t.nb_pass_o_sport,
                core.Price.pass_o_sport)
    if t.SI_code == 0:
        msg = msg + (
            "* Location pointeur : 1 x Gratuit euros\n")
    want = "Non"
    if t.want_news_letter:
        want = "Oui"
    msg = msg + (
        "Montant total à régler : {0} euros\n\n"
        "DIVERS : \n"
        "--------\n"
        "Abonnement news letters : {1}\n"
        "Message : {2}\n\n"
        "Sportivement,\n"
        "L'équipe de Dinan Course d'Orientation\n"
        "Courriel : secretariat@dinan-course-orientation.fr\n"
        "Site internet : http://www.dinan-course-orientation.fr\n").format(
            t.price, want, message)

    return msg

# =============================================================================
# Message html
# =============================================================================


def message_html():
    msg = (
        '<html><head>'
        '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">'
        '<title>Message</title>'
        '</head>'
        '<body style="font-family: Arial, Helvetica, sans-serif;">'
        '<p>Chers amis orienteurs,</p>'
        '<p>Merci de vous être pré-inscrit à la ' + TYPE + ' - ' + CITY + ' - ' + YEAR + '.</p>'
        '<p>Pour compléter votre dossier d\'inscription, veuillez nous '
        'envoyer :</p>'
        '<ul>'
        '<li>ce message qui nous rappelle vos coordonnées</li>')
    if t.SI_code == 0:
        msg = msg + (
            '<li>un chèque de caution de 50 euros à l\'ordre de '
            '"Dinan Course d\'Orientation" (non encaissé et couvrant la '
            'valeur du pointeur électronique)</li>')
    r = core.Race()
    r.select(t.race_code)
    if r.is_chrono:
        for p in t.persons:
            if p.FFCO_code == 0:
                msg = msg + (
                    "<li>l'attestation médical de {0} {1} (modèle téléchargeable sur la page d'information de la " + TYPE + ")</li>").format(p.first_name,p.name)
            
    msg = msg + (
        '<li> un chèque de règlement de {0} euros à l\'ordre de '
        '"Dinan Course d\'Orientation"</li>').format(t.price)
    msg = msg + (
        '</ul>'
        '<p>Le courrier doit être posté à l\'adresse suivante :</p>'
        '<p>' + RECEIVER + '</p>'
        '<p>Par le fait de vous inscrire, vous reconnaissez que tous les '
        'coureurs composant l\'équipe s\'engagent à respecter le réglement de '
        'la course disponible à cette adresse : '
        '<a href="'+ WEB_PAGE + '">' + WEB_PAGE + '</a>.</p>'
        'Si vous souhaitez effectuer une modification de votre dossier '
        'd\'inscription ou simplement poser une question, n\'hésitez pas à '
        'nous contacter par messagerie ou à l\'aide du formulaire de contact '
        'sur notre site internet.</p>')
    msg = msg + (
        '<p>Sportivement,</p>'
        '<p><i>L\'équipe de Dinan Course d\'Orientation<br>'
        'Courriel : secretariat@dinan-course-orientation.fr<br>'
        'Site internet : <a href="http://www.dinan-course-orientation.fr">'
        'http://www.dinan-course-orientation.fr</a></i></p>')
    if len(t.persons) > 1:
        t.nb_map = 2
    msg = msg + (
        "<hr>"
        "<p><b>Votre équipe </b><br>"
        "Nom de l'équipe : {0}<br>"
        "Courriel de l'équipe : {1}<br>"
        "Téléphone portable : {2}<br>"
        "Parcours : {3}<br>").format(
            cgi.escape(t.name, quote=True),
            cgi.escape(t.mail, quote=True),
            cgi.escape(t.phone, quote=True),
            core.Race(code=t.race_code).label)
            
    si_code = "Location"
    if t.SI_code > 0:
        si_code = str(t.SI_code)
    msg = msg + "Pointeur SI : {0}".format(si_code)
    
    for i, p in enumerate(t.persons):
        ffco = "Pass\'O"
        if p.FFCO_code > 0:
            ffco = str(p.FFCO_code)
        if not i:
            msg = msg + "<p><b>Capitaine</b><br>"
        else:
            msg = msg + "<p><b>Equipier " + str(i) + "</b><br>"
        msg = msg + (
            "Nom : {0}<br>"
            "Prénom : {1}<br>"
            "Date de naissance : {2}/{3}/{4}<br>"
            "Licence FFCO : {5}</p>").format(
                cgi.escape(p.name, quote=True),
                cgi.escape(p.first_name, quote=True),
                p.day,
                p.month,
                p.year,
                ffco)

    msg = msg + (
        "<p><b>A régler</b></p>"
        "<ul>")
    msg = msg + ("<li>Carte : {0} euros</li>").format(core.Price.map_set)
    if t.nb_adult > 0:
        msg = msg + (
            "<li>Engagement adulte (plus 18 ans) : "
            "{0} x {1} euros</li>").format(
                t.nb_adult,
                core.Price.adult)
    if t.nb_young > 0:
        msg = msg + (
            "<li>Engagement jeune (14 à 17 ans) : "
            "{0} x {1} euros</li>").format(
                t.nb_young,
                core.Price.young)
    if t.nb_child > 0:
        msg = msg + (
            "<li>Engagement enfant (6 à 13 ans) : "
            "{0} x {1} euros</li>").format(
                t.nb_child,
                core.Price.child)
    if t.nb_baby > 0:
        p = ""
        if core.Price.baby == 0:
            p = "Gratuit"
        else:
            p = str(t.nb_baby * core.Price.baby), " €"
        msg = msg + (
            "<li>Engagement poussin (moins 6 ans) : "
            "{0} x {1} euros</li>").format(
                t.nb_baby, p)
    if t.nb_pass_o_leasure > 0 :
        msg = msg + (
            "<li>Pass\'loisir (licence journée non-chrono) : "
            "{0} x {1} euros</li>").format(
                t.nb_pass_o_leasure,
                core.Price.pass_o_leasure)
    if t.nb_pass_o_sport:
        msg = msg + (
            "<li>Pass\'découverte (licence journée chrono) : {0} x {1} euros</li>").format(
                t.nb_pass_o_sport,
                core.Price.pass_o_sport)
    if t.SI_code == 0:
        msg = msg + (
            "<li>Location pointeur : 1 x Gratuit euros</li>")
    msg = msg + (
        "<li>Montant total à régler : <b>{0} euros</b></li>").format(t.price)
    msg = msg + "</ul>"

    want = "Non"
    if t.want_news_letter:
        want = "Oui"
    msg = msg + (
        "<p><b>Divers</b><br>"
        "Abonnement news letters : {0}<br>"
        "Message : {1}</p>"
        "<hr>").format(want, cgi.escape(message, quote=True))
    msg = msg + ('</body></html>')

    return msg

# =============================================================================
# GEC ascii
# =============================================================================


def GEC_ascii():
    msg = (
        "CSV TRESORIE \n\n{0}"
        "\n\n\n"
        "CSV INSCRIPTION \n\n{1}"
        "\n\n\n"
        "CSV GEC \n\n{2}"
        "\n\n\n{3}").format(
            t.tresorerie_csv,
            t.csv,
            t.geraid_csv,
            message_ascii())
    return msg

# =============================================================================
# GEC html
# =============================================================================


def GEC_html():
    msg = (
        '<html><head>'
        '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">'
        '<title>Message</title>'
        '</head>'
        '<body style="font-family: Arial, Helvetica, sans-serif;">'
        '<p>CSV trésorerie</p>'
        '<pre>{0}</pre>'
        '<hr>'
        '<p>CSV inscription</p>'
        '<pre>{1}</pre>'
        '<hr>'
        '<p>CSV GeRaid</p>'
        '<pre>{2}</pre>'
        '<hr>{3}').format(
            t.tresorerie_csv,
            t.csv,
            t.geraid_csv,
            message_html())
    return msg

# =============================================================================
# Main ...
# =============================================================================

# Init
cgitb.enable()
errors = []
t = core.Team()
p = core.Person()
spam = core.Spam()
mail_check = ""
message = ""

# Reading ops values
form = cgi.FieldStorage()

if form.getvalue("state"):
    state = form.getvalue("state")
else:
    state = "NEW"

if form.getvalue("page"):
    page = form.getvalue("page")
    if page == "Etape suivante":
        page = "REPORT"
    elif page == "Corriger":
        page = "FORM"
    elif page == "Envoyer":
        page = "SEND"
else:
    page = "FORM"

# Team values
if form.getvalue("team_name"):
    t.name = form.getvalue("team_name").strip()
if page != "SEND" and state != "NEW":
    if len(t.name) == 0:
        errors.append(ERR_TEAM_NAME_MANDATORY)

if form.getvalue("team_mail"):
    t.mail = form.getvalue("team_mail").strip()
if page != "SEND" and state != "NEW":
    if len(t.name) == 0:
        errors.append(ERR_TEAM_MAIL_MANDATORY)

if form.getvalue("mail_check"):
    mail_check = form.getvalue("mail_check").strip()
if page != "SEND" and state != "NEW":
    if len(mail_check) > 0:
        if not t.check_mail(mail_check):
            errors.append(ERR_TEAM_MAIL_VALIDATION)
    else:
        errors.append(ERR_TEAM_MAIL_CHECK_MANDATORY)

if form.getvalue("team_phone"):
    t.phone = form.getvalue("team_phone").strip()
if page != "SEND" and state != "NEW":
    if len(t.phone) == 0:
        errors.append(ERR_TEAM_PHONE_MANDATORY)

if form.getvalue("team_race_code"):
    t.race_code = form.getvalue("team_race_code").strip()
if page != "SEND" and state != "NEW":
    if t.race_code == "NONE":
        errors.append(ERR_TEAM_RACE_MANDATORY)
        
if form.getvalue("team_si_code"):
    c = form.getvalue("team_si_code").strip()
    if not c.isdigit():
        errors.append(ERR_TEAM_SI_CODE_NUMBER)
    else:
        t.SI_code = int(c)
        if t.SI_code > 0:
            if core.Card(code=t.SI_code).label != "NONE":
                if core.Race(code=t.race_code).nb_tag > core.Card(code=t.SI_code).mem:
                    errors.append(ERR_TEAM_SI_UNUSABLE)
            else:
                errors.append(ERR_TEAM_SI_UNKNOWN)

# Person N values
for i in range(6):
    p = core.Person()
    if form.getvalue("persons_" + str(i) + "_name"):
        p.name = form.getvalue("persons_" + str(i) + "_name").strip()
        
    if form.getvalue("persons_" + str(i) + "_first_name"):
        p.first_name = form.getvalue("persons_" + str(i) + "_first_name").strip()
    
    if form.getvalue("persons_" + str(i) + "_day"):
        p.day = int(form.getvalue("persons_" + str(i) + "_day"))
    
    if form.getvalue("persons_" + str(i) + "_month"):
        p.month = int(form.getvalue("persons_" + str(i) + "_month"))
    
    if form.getvalue("persons_" + str(i) + "_year"):
        p.year = int(form.getvalue("persons_" + str(i) +"_year"))
    
    if form.getvalue("persons_" + str(i) + "_ffco_code"):
        c = form.getvalue("persons_" + str(i) + "_ffco_code").strip()
        if not c.isdigit():
            errors.append(p.error_ffco_code_number(i))
        else:
            p.FFCO_code = int(c)

    if not p.is_empty:
        t.add_person(
            core.Person(
                name=p.name,
                first_name=p.first_name,
                day=p.day,
                month=p.month,
                year=p.year,
                FFCO_code=p.FFCO_code))
        if page != "SEND" and state != "NEW":
            if len(p.name) == 0:
                errors.append(p.error_name(i))
            if len(p.first_name) == 0:
                errors.append(p.error_first_name(i))
            if p.day == 0:
                errors.append(p.error_day(i))
            if p.month == 0:
                errors.append(p.error_month(i))
            if p.year == 0:
                errors.append(p.error_year(i))

# Others
if form.getvalue("message"):
    message = form.getvalue("message").strip()

if form.getvalue('team_want_news_letter'):
    if form.getvalue("team_want_news_letter") == "Y":
        t.want_news_letter = True

# Checking anti-spam
if form.getvalue("spam_code"):
    spam.select(int(form.getvalue("spam_code")))
if state == "NEW":
    spam.get_random()
elif page == "REPORT" and state == "VALIDATE":
    if spam.code == 9999:
        errors.append(ERR_SPAM_TECHNICAL_ERROR_1)
    if form.getvalue("spam_response"):
        if not spam.validate(form.getvalue("spam_response").strip()):
            errors.append(ERR_SPAM_RESPONSE_BAD)
        else:
            state = "EDIT"
    else:
        errors.append(ERR_SPAM_RESPONSE_MANDATORY)

# Final checking
if page != "SEND" and state != "NEW":
    if len(t.persons) == 0:
        errors.append(ERR_PERSON_MANDATORY)

# Dispatching
if state == "NEW":
    state = "VALIDATE"
    display_team_registation()
elif page == "REPORT":
    if len(errors) == 0:
        display_report()
    else:
        spam.get_random()
        display_team_registation()
elif page == "FORM":
    display_team_registation()
elif page == "SEND":
    # Mail to team
    mail = core.Mail()
    mail.address_from = "secretariat@dinan-course-orientation.fr"
    mail.address_to = t.mail
    mail.address_copy = "secretariat@dinan-course-orientation.fr"
    mail.address_reply = "secretariat@dinan-course-orientation.fr"
    mail.subject = "Inscription " + TYPE + " - " + CITY + " - " + YEAR 
    mail.msg_ascii = message_ascii()
    mail.msg_html = message_html()
    e = mail.send()
    for err in e:
        errors.append(err)
    # Mail to GEC
    mail = core.Mail()
    mail.address_from = t.mail
    mail.address_to = "secretariat@dinan-course-orientation.fr"
    mail.subject = (
        "Inscription " + TYPE + " - " + CITY + " - " + YEAR + "- Tech part")
    mail.msg_ascii = GEC_ascii()
    mail.msg_html = GEC_html()
    e = mail.send()
    for err in e:
        errors.append(err)
    # Then dispatch
    if len(errors) > 0:
        display_report()
    else:
        display_ok()

# End
